﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Entity;
using System.Linq.Expressions;

namespace Domain
{
	public class DomainContext : DbContext, IDomainContext
	{
		static DomainContext()
		{
			QueryableExtensions.Includer = new DbIncluder();
		}

		public virtual DbSet<Product> Products { get; set; }

		void IDomainContext.SaveChanges()
		{
			this.SaveChanges();
		}

		IQueryable<Product> IDomainContext.Products
		{
			get { return this.Products.Where(x => !x.IsDeleted); }
		}

		public void Save<T>(T entity) where T : class, IEntity
		{
			this.Set<T>().Add(entity);
		}

		public void Delete<T>(long id) where T : class, IEntity
		{
			var saved = this.Set<T>().Find(id);

			saved.IsDeleted = true;
		}
		private class DbIncluder : QueryableExtensions.IIncluder
		{
			public IQueryable<T> Include<T, TProperty>(IQueryable<T> source, Expression<Func<T, TProperty>> path)
				where T : class
			{
				return DbExtensions.Include(source, path);
			}
		}
	}
}
